/*
  OS_checking_04
  repeat
  
  works pretty good, but NOT with USB_volts
  demo not right till 5V lab supply
  [ USB is marginal, typ IRrcvr module Vmin = 4V7
  
 */
 
int passes = 0;
byte x = 0;
byte dets = 0;

void setup() 
{  
  // 38kc bursts xmit on D3 for 38kc IR rcvr 
  // LO means IR is present (active state)
  // initialize the digital pin as an output.
  // D3 has an IRED connected
  pinMode(3, OUTPUT);          // IRED aka XMTR
  pinMode(4, INPUT);           // 38kc DET
  pinMode(5, OUTPUT);          // EVENT! annunciator (no beam!)
  delay(1000);   
}

void loop() 
{    
   while (passes < 25)          // est. beam, overcome det
                                // latency: it's slow to det
                                // (slow to release, too, but
                                // that's not a concern)
                                // Doesn't need to be this
                                // long, but that's where
                                // it is.
   {
      digitalWrite(3, HIGH);   // set the LED on
      delayMicroseconds(13);   // wait for 13usec
      digitalWrite(3, LOW);    // set the LED off
      delayMicroseconds(2);
      x = digitalRead(4);      // 
      
      if (passes > 15 && x == 1)  // 
        {
          dets ++;
        }
        
      passes ++;               //  
   }    

   if (dets == 0)             // beam was not broken
     {
        delayMicroseconds(120);
     }
   if (dets > 0)             //  beam was broken
     {
        digitalWrite(5, HIGH);
        delay(2500);
        digitalWrite(5, LOW);
     }
   passes = 0;
   dets = 0;
}    
